stat_modeLetter = 0
stat_permission = 1
stat_time = 2
stat_linkto = 3
stat_size = 4
stat_user = 5
stat_group = 6

import re,string,os,sys,time,types

#===================================== 
def ls2stat_ini(): # initial ls2stat to reduce overhead
#===================================== 
  global ls2stat_p1,ls2stat_p2,ls2stat_p3,ls2stat_p4,ls2stat_month2v,ls2stat_fInfo,yearNow,monthNow,dayNow,ls2stat_v2month
# 0: d or l;  1: per;  2: mon;  3: date;  4: min;  5: fname
# ls2stat_p1 = re.compile(r'^([dl-])((?:[r-][w-][x-]){3,3}).*?\d ([A-Z][a-z]{2,2}) {1,2}(\d{1,2}) (\d\d\:\d\d| (?:19|20)\d\d) (\S.*?)(?:\s*$|\*$|/$)')
  ls2stat_p1 = ' '
  ls2stat_p2 = re.compile(r'(?:19|20)\d\d') 
  ls2stat_p3 = re.compile(r'[wxXrsltT]')
  ls2stat_p4 = re.compile(r'-')

  ls2stat_month2v = {'Jan': 1, 'Feb':2, 'Mar':3, 'Apr':4, 'May':5, 'Jun':6,\
             'Jul':7, 'Aug':8, 'Sep':9, 'Oct':10, 'Nov':11, 'Dec':12}

  ls2stat_v2month = ls2stat_month2v.keys()
  for key in ls2stat_month2v.keys():
    ls2stat_v2month[ls2stat_month2v[key]-1] = key

  ls2stat_fInfo = {}

  temp1 = time.localtime(time.time())
  yearNow = temp1[0]
  monthNow = temp1[1]
  dayNow = temp1[2]

#===================================== 
def engine(line):
#===================================== 
# print line
  if line[-1]=='\n':
    line = line[:-1]
  words = string.split(line, None, 8)

  wrongLine = 0
  if not len(words)==9:
    wrongLine = 1
  if len(words)==9:
    if (not words[0][0] in 'dl-') or (not words[0][1] in 'r-'):
#     print 'Skipping the following line in scanning filenames:\n%s\n' % line
      wrongLine = 1
  if wrongLine:
    return 
  fileName = string.lstrip(words[-1])

  i = string.find(fileName, " -> ")
  link = 0
  if i >= 0:
#   print 'Found symbolic link %s' % `fileName`
    linkto = fileName[i+4:]
    fileName = fileName[:i]
    link = 1

  mode0 = words[0][0]
  mode1 = words[0][1:]
  if len(mode1)>9: mode1 = mode1[:9]
  mode1 = ls2stat_p3.sub('1',mode1)
  mode1 = ls2stat_p4.sub('0',mode1)
  try:
    mode2 = string.atoi(mode1,2)
  except: 
    print '%s: illegal mode %s' % (fileName, mode1)
    sys.exit(1)

  year = yearNow
  month = ls2stat_month2v[words[5]]
  day = int(words[6])

  if ls2stat_p2.match(words[7]):
    year = int(words[7])
    time1 = '00:00'
  else:
    time1 = words[7]
    if month>monthNow:
      year = yearNow-1
  minute = int(time1[0:2]) 
  second = int(time1[3:]) 

  timeTup = ( year, month, day, minute, second, 0,0,0,-1)
  timeSec = time.mktime(timeTup)
#   print timeTup, timeSec

  size = string.atoi(words[4])

  if link==1:
    return [fileName, mode0, mode2, timeSec,linkto,size]
  else:
    return [fileName, mode0, mode2, timeSec,'',size]

#===================================== 
def reverseEngine(fileName,stat1):
#===================================== 
    mode = stat1[stat_permission]
    timeSec = stat1[stat_time]

    if stat1[stat_modeLetter]=='l':
      linkto = stat1[stat_linkto]
      fileName = '%s -> %s' % (fileName, linkto)

    modeStr1 = mode2str(mode)

    temp1 = time.localtime(timeSec)
    year,month,day,minute,second = (temp1[0],temp1[1],temp1[2],temp1[3],temp1[4])
#   print fileName, year,month,day,minute,second
    monthStr = ls2stat_v2month[month-1]
#   print fileName, monthStr
    if minute==0 and second==0 and year<yearNow:
      timeOrYear = ' %4d' % year
    else:
      timeOrYear = '%02d:%02d' % (minute,second)

    sizeStr = string.rjust('%s' % stat1[stat_size], 12)

    str1 = '%s%s  1 aaaa    user %s %s %2d %s %s' % \
       (stat1[stat_modeLetter], modeStr1, sizeStr, monthStr, day, timeOrYear, fileName)
#   print modeStr1, timeOrYear, fileName 
    return str1
#rwxr-xr-x   2 aaaa    user         1024 May  2 17:21 tmp9/
#rwxr-xr-x  1 aaaa    user         1024 Dec  5 15:43 bin

#===================================== 
def mode2str(mode):  
#===================================== 
  modeStr0 = ''
  mode1 = mode
  for i in [8,7,6,5,4,3,2,1]:
    temp1 = mode1/2**i
    mode1 = mode1 - temp1*2**i 
    modeStr0 = '%s%1d' % (modeStr0, temp1)
  modeStr0 = '%s%1d' % (modeStr0, mode1)

  modeStr0 = string.replace(modeStr0,'0','-')
  temp1 = 'rwxrwxrwx'
  modeStr = ''
  for i in range(9):
    if modeStr0[i]=='1': modeStr = modeStr + temp1[i]
    else: modeStr = modeStr + modeStr0[i]
   
  return modeStr

#===================================== 
def ls2statL(line): # similar w/ ls2stat but for single line. for use with ftplib
#===================================== 
# print line
  temp9 = engine(line)
  if temp9:
    ls2stat_fInfo[temp9[0]] = temp9[1:]

#===================================== 
def ls2stat(lines): 
# from output of ls -l to dict of name:[fileType, permissionBit, epochTime]
#===================================== 
  if type(lines)==types.StringType:
    lines = str2list(lines)

  dict1 = {}
  for line in lines:
#   print line
    temp9 = engine(line)
    if temp9:
      dict1[temp9[0]] = temp9[1:]
  return dict1

#===================================== 
def stat2ls(dict1): 
#===================================== 
  lines = []
  for key in dict1.keys():
    lines.append( reverseEngine(key,dict1[key]) + '\n' )
  return lines
# for line in lines: print line

#===================================== 
def setFileStat(fileName,stat1):
#===================================== 
    mode = stat1[stat_permission]
    timeSec = stat1[stat_time]

    if stat1[stat_modeLetter]=='l':
      linkto = stat1[stat_linkto]
      try:
	os.remove(fileName)
      except: pass
      os.symlink(linkto, fileName)
#     os.utime(fileName, (timeSec,timeSec))  # no use for setting time of a soft link

    elif os.path.isfile(fileName) or os.path.isdir(fileName):
      os.chmod(fileName, mode)
      os.utime(fileName, (timeSec,timeSec))

    else:  
      print 'setFileStat: Cannot find %s' % fileName
      return

#===================================== 
def str2list(str1,sep1='\012'):
#===================================== 
  if type(str1)==types.StringType:
    list1 = string.split(str1,sep1)
    if list1[0] =='':
      del list1[0]; 
    if list1[-1] =='':
      del list1[-1]; 
  return list1

#========================================
ls2stat_ini()

